Index: src/Fl_Native_File_Chooser_WIN32.cxx
===================================================================
--- src/Fl_Native_File_Chooser_WIN32.cxx	(revision 10687)
+++ src/Fl_Native_File_Chooser_WIN32.cxx	(working copy)
@@ -23,6 +23,7 @@
 
 #ifndef FL_DOXYGEN		// PREVENT DOXYGEN'S USE OF THIS FILE
 #include <FL/Enumerations.H>
+#include <FL/Fl.H>
 
 #if FLTK_ABI_VERSION < 10304
 #define _ofn_ptr (&_ofn)
@@ -568,13 +569,21 @@
 //   -1 - failed; errmsg() has reason
 //
 int Fl_Native_File_Chooser::show() {
+  int retval;
   if ( _btype == BROWSE_DIRECTORY ||
        _btype == BROWSE_MULTI_DIRECTORY ||
        _btype == BROWSE_SAVE_DIRECTORY ) {
-    return(showdir());
+    retval = showdir();
   } else {
-    return(showfile());
+    retval = showfile();
   }
+  Fl_Widget *wid = Fl::focus();
+  HWND h = (wid ? fl_xid(wid->top_window()) : 0);
+  if (h) {
+    WNDPROC windproc = (WNDPROC)GetWindowLongPtrW(h, GWLP_WNDPROC);
+    CallWindowProc(windproc, h, WM_ACTIVATEAPP, 1, 0); // STR #3221
+  }
+  return retval;
 }
 
 // RETURN ERROR MESSAGE
